Life in a Terminal Window
=========================

Paul Nijjar

2019-07-08

Kitchener-Waterloo Linux User Group





What??
------

Why bother with terminal programs in 2019?

- Maybe your computer is too slow for the modern internet

- Maybe you have a tiling window manager

- Maybe you want to get work done in an SSH window (with no
  X-forwarding)

- Maybe you hate notifications

- Maybe you are a dinosaur

- (Mikalai) Maybe you are working inside containers


Goals
-----

- New users: get a sense of what is available from the terminal
  + Give you nouns to search for, as opposed to keystrokes

- Experienced users: maybe get a tip or two you did not know before
  + What are the quirks?

- Me: maybe get suggestions for other useful tools


Caveats
-------

- I run old old Debian

- I am not a computer genius

- I am not a life hacker/optimizer

- These are the programs I actually use, not always the ones I ought
  to use

- Muscle memory is a walled garden


Oops
----

I did not bother preparing more slides!

What now?

Let's improvise!


Basics
------

- tiling window manager: spectrwm 
- multiplexer: screen
    + See <https://kwlug.org/node/687
- x-terminal-emulator: xterm
- editor: vim

Internets
---------

- join a network: wicd-curses
- surf the internets: w3m 
    + no javascript
    + cookies are sketch
    + set a browser with o
    + use another browser with m
    + great interface for forms (opens an editor for text fields)
- search: duckduckgo with a shortcut
- read news: newsbeuter/newsboat
    + o to open a news item in a screen
    + supports different profiles via environment variables
    + gets slow on huge archives, but is overall good
- google calendars: gcalcli
    + Use this with a script to populate Watcamp
- passwords: yapet
    + uses blowfish encryption
- mail: mutt
    + configurable
    + supports different profiles
    + forwarding attachments is hard
    + html mails are okay (uses w3m)

Multimedia
----------

- audio mixing: alsamixer
- music and videos: vlc 
    + no displays: vlc --intf rc
        * bad for seeking
        * great for playing music in the background
    + terminal interface: vlc --intf ncurses
- get videos and such: youtube-dl
    + install dependencies with apt, but not the script
    + there are flags for smaller videos
    + It works on more than youtube
- MP3 info: eyeD3
- view images: sxiv
    + there are many others, but this is smooth and effective



Audience suggestions
--------------------

- Painting program: krita
- Art program: photopea
    + works in a browser but can be containerized
- avconv: audio editing via a script
    + ncurses interface: nobody knows
    + Look for Raul's presentation for video editing
      <https://kwlug.org/node/854>



Other utilities (not in presentation)
-------------------------------------

- look up synonyms/spellings/translations: dict
- spel wurds: wurdspel script
- convert PDF to text: pdftotext
- calculator: bc
- interactive file explorer: mc
- look at calendars: cal
- remember important dates: calendar


Things I wish I had, but don't (yet)
------------------------------------

- XLSX spreadsheet viewer
- Maybe a DOCX reader/extractor
- Generic iCal client
- Twitter client
- Slack client
- Maybe a better podcatcher
    + I use gpodder and it is okay but slow
    + newsbeuter/newsboat has support for podcasts
- web browser for javascript















